#!/bin/sh
#
# chkconfig:	345 91 35
# description:	Starts and stops an ADSL connection

# Source function library.
. /etc/rc.d/init.d/functions

# Source networking configuration.
. /etc/sysconfig/network

# Check that networking is up.
[ ${NETWORKING} = "no" ] && exit 0


HCD=usb-uhci

# See how we were called.
case "$1" in
  start)
	# usbcore is already loaded by mount 
		modprobe $HCD
		/usr/local/bin/modem_run -f /home/papillau/c/speedtouch/microcode.bin \
			-m
		modprobe ppp_synctty
		pppd call adsl
        ;;
  stop)
		poff
		rmmod $HCD
        ;;
  restart)
	$0 stop
	$0 start
	;;
  *)
	echo "Usage: $0 {start|stop|restart}"
	exit 1
esac





