#ifndef pool_h
#define pool_h

struct buffer
{
  /* a pointer to the memory allocated for this buffer */
  void * buf;

  /* size of the buffer allocated : the same size for all the buffer */
  int    size;

  /* =0 is the entry is free, =1 if it is in use by someone */
  int    allocated;
};

struct pool
{
  /* pointer to an array of 'buffer' */
  struct buffer * buf_list;
  
  /* number of elements in the 'buf_list' array */
  int             buf_nb;
};

/* All the following functions returns 1 in case of sucess
   and 0 in case of failure */

/* buffer_pool_init : 'nb' is the number of buffer to allocate
   and 'size' if the size in bytes of each buffer */

extern int buffer_pool_init(struct pool *p, int nb,int size);

/* buffer_pool_alloc : is used to reserved to buffer in the pool.
   a pointer to the 'buffer' allocated is returned in 'tbuf'
*/

extern int buffer_pool_alloc(struct pool *p, struct buffer ** tbuf);

/* buffer_pool_free : the 'buffer' is made available to the pool */

extern int buffer_pool_free(struct pool *p, struct buffer * tbuf);

/* search for a matching buffer containig 'ptr'. returns NULL if not found */

extern struct buffer * buffer_pool_search(struct pool *p, void * ptr);

#endif
